---
title: WebGLRenderingContext.framebufferRenderbuffer()
slug: Web/API/WebGLRenderingContext/framebufferRenderbuffer
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.framebufferRenderbuffer()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> attaches a {{domxref("WebGLRenderbuffer")}} object to a {{domxref("WebGLFramebuffer")}} object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.framebufferRenderbuffer(<var>target</var>, <var>attachment</var>, <var>renderbuffertarget</var>, <var>renderbuffer</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>target</dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target) for the framebuffer. Possible values:
 <ul>
  <li><code>gl.FRAMEBUFFER</code>: Collection buffer data storage of color, alpha, depth and stencil buffers used to render an image.</li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.DRAW_FRAMEBUFFER</code>: Equivalent to <code>gl.FRAMEBUFFER</code>. Used as a destination for drawing, rendering, clearing, and writing operations.</li>
    <li><code>gl.READ_FRAMEBUFFER</code>: Used as a source for reading operations.</li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>attachment</dt>
 <dd>A {{domxref("GLenum")}} specifying the attachment point for the render buffer. Possible values:
 <ul>
  <li><code>gl.COLOR_ATTACHMENT0</code>: color buffer.</li>
  <li><code>gl.DEPTH_ATTACHMENT</code>: depth buffer.</li>
  <li><code>gl.DEPTH_STENCIL_ATTACHMENT</code>: depth and stencil buffer.</li>
  <li><code>gl.STENCIL_ATTACHMENT</code>: stencil buffer.</li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.COLOR_ATTACHMENT1<br>
     gl.COLOR_ATTACHMENT2<br>
     gl.COLOR_ATTACHMENT3<br>
     gl.COLOR_ATTACHMENT4<br>
     gl.COLOR_ATTACHMENT5<br>
     gl.COLOR_ATTACHMENT6<br>
     gl.COLOR_ATTACHMENT7<br>
     gl.COLOR_ATTACHMENT8<br>
     gl.COLOR_ATTACHMENT9<br>
     gl.COLOR_ATTACHMENT10<br>
     gl.COLOR_ATTACHMENT11<br>
     gl.COLOR_ATTACHMENT12<br>
     gl.COLOR_ATTACHMENT13<br>
     gl.COLOR_ATTACHMENT14<br>
     gl.COLOR_ATTACHMENT15</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("WEBGL_draw_buffers")}} extension:
   <ul>
    <li><code>ext.COLOR_ATTACHMENT0_WEBGL</code> (same as <code>gl.COLOR_ATTACHMENT0</code>)<br>
     <code>ext.COLOR_ATTACHMENT1_WEBGL<br>
     ext.COLOR_ATTACHMENT2_WEBGL<br>
     ext.COLOR_ATTACHMENT3_WEBGL<br>
     ext.COLOR_ATTACHMENT4_WEBGL<br>
     ext.COLOR_ATTACHMENT5_WEBGL<br>
     ext.COLOR_ATTACHMENT6_WEBGL<br>
     ext.COLOR_ATTACHMENT7_WEBGL<br>
     ext.COLOR_ATTACHMENT8_WEBGL<br>
     ext.COLOR_ATTACHMENT9_WEBGL<br>
     ext.COLOR_ATTACHMENT10_WEBGL<br>
     ext.COLOR_ATTACHMENT11_WEBGL<br>
     ext.COLOR_ATTACHMENT12_WEBGL<br>
     ext.COLOR_ATTACHMENT13_WEBGL<br>
     ext.COLOR_ATTACHMENT14_WEBGL<br>
     ext.COLOR_ATTACHMENT15_WEBGL</code></li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>renderbuffertarget</dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target) for the render buffer. Possible values:
 <ul>
  <li><code>gl.RENDERBUFFER</code>: Buffer data storage for single images in a renderable internal format.</li>
 </ul>
 </dd>
 <dt>renderbuffer</dt>
 <dd>A {{domxref("WebGLRenderbuffer")}} object to attach.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>A <code>gl.INVALID_ENUM</code> error is thrown if <code>target</code> is not <code>gl.FRAMEBUFFER</code>, <code>gl.DRAW_FRAMEBUFFER</code>, or <code>gl.READ_FRAMEBUFFER</code>.</li>
 <li>A <code>gl.INVALID_ENUM</code> error is thrown if <code>renderbuffertarget</code> is not <code>gl.RENDERBUFFER</code>.</li>
 <li>A <code>gl.INVALID_ENUM</code> error is thrown if <code>attachment</code> is not one of the allowed enums.</li>
</ul>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.framebufferRenderbuffer(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.RENDERBUFFER, renderbuffer);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.6", "framebufferRenderbuffer")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glFramebufferRenderbuffer.xml", "glFramebufferRenderbuffer")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glFramebufferRenderbuffer.xhtml", "glFramebufferRenderbuffer")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.framebufferRenderbuffer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.createFramebuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.deleteFramebuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.isFramebuffer()")}}</li>
 <li>Other buffers: {{domxref("WebGLBuffer")}}, {{domxref("WebGLRenderbuffer")}}</li>
 <li>{{domxref("WEBGL_draw_buffers")}}</li>
</ul>
